	@library	pplib

;************** Start of Fargo library ***************

	label	decrunch
	movem.l	d0-d7/a2-a3,-(a7)
	moveq	#3,d6
	moveq	#7,d7
	moveq	#1,d5
	move.l	a3,a2
	move.l	-(a0),d1
	tst.b	d1
	beq	NoEmptyBits
	bsr	ReadBit
	subq.b	#1,d1
	lsr.l	d1,d5
NoEmptyBits:
	lsr.l	#8,d1
	add.l	d1,a3
LoopCheckCrunch:
	bsr	ReadBit
	bcs	CrunchedBytes
NormalBytes:
	moveq	#0,d2
Read2BitsRow:
	moveq	#1,d0
	bsr	ReadD1
	add.w	d1,d2
	cmp.w	d6,d1
	beq	Read2BitsRow
ReadNormalByte:
	moveq	#7,d0
	bsr	ReadD1
	move.b	d1,-(a3)
	dbf	d2,ReadNormalByte
	cmp.l	a3,a2
	bcs	CrunchedBytes
	rts
ReadBit:
	lsr.l	#1,d5
	beq	GetNextLong
	rts
GetNextLong:
	move.l	-(a0),d5
	roxr.l	#1,d5
	rts
ReadD1sub:
	subq.w	#1,d0
ReadD1:
	moveq	#0,d1
ReadBits:
	lsr.l	#1,d5
	beq	GetNext
RotX:
	roxl.l	#1,d1
	dbf	d0,ReadBits
	rts
GetNext:
	move.l	-(a0),d5
	roxr.l	#1,d5
	bra	RotX
CrunchedBytes:
	moveq	#1,d0
	bsr	ReadD1
	moveq	#0,d0
	move.b	0(a5,d1.w),d0
	move.w	d1,d2
	cmp.w	d6,d2
	bne	ReadOffset
	bsr	ReadBit
	bcs	LongBlockOffset
	moveq	#7,d0
LongBlockOffset:
	bsr	ReadD1sub
	move.w	d1,d3
Read3BitsRow:
	moveq	#2,d0
	bsr	ReadD1
	add.w	d1,d2
	cmp.w	d7,d1
	beq	Read3BitsRow
	bra	DecrunchBlock
ReadOffset:
	bsr	ReadD1sub
	move.w	d1,d3
DecrunchBlock:
	addq.w	#1,d2
DecrunchBlockLoop:
	move.b	0(a3,d3.w),-(a3)
	dbf	d2,DecrunchBlockLoop
EndOfLoop:
	cmp.l	a3,a2
	bcs	LoopCheckCrunch
	movem.l	(a7)+,d0-d7/a2-a3
	rts

;*************** End of Fargo library ****************

	reloc_open
	reloc_close
	end
